/*
lqrn.hh

This C++ header file defines the NML Messages used for command and status by LQR_MODULE
Template Version 1.1

MODIFICATIONS:
13-Sep-99	Created by rcsdesign.

*/

// Prevent Multiple Inclusion
#ifndef LQRN_HH
#define LQRN_HH

// Include Files
#include "rcs.hh" 	// Common RCS definitions

// Predefined type files
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.
#define PLANT_ORDER 4


// Define the integer type ids.
//  RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

#define LQR_STATUS_TYPE 1000
#define LQR_HALT_TYPE 1001
#define LQR_INIT_TYPE 1002
#define LQR_RUN_TYPE 1003
#define LQR_SET_GAINS_TYPE 1004
//  RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


// Define the NML Message Classes

// Status Class
class LQR_STATUS : public RCS_STAT_MSG
{
public:

	// Normal Constructor
	LQR_STATUS();

	// Constructor used by derived classes
	LQR_STATUS(NMLTYPE t, size_t s) :  RCS_STAT_MSG(t,s) {};

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double plant_state[PLANT_ORDER];
  double ctrl_output;

};

// Command Classes

class LQR_HALT : public RCS_CMD_MSG
{
public:

	//Constructor
	LQR_HALT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class LQR_INIT : public RCS_CMD_MSG
{
public:

	//Constructor
	LQR_INIT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class LQR_RUN : public RCS_CMD_MSG
{
public:

	//Constructor
	LQR_RUN();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double reference_input;

};

class LQR_SET_GAINS : public RCS_CMD_MSG
{
public:

	//Constructor
	LQR_SET_GAINS();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double lqr_gains[PLANT_ORDER];

};

// Declare NML format function
extern int lqrFormat(NMLTYPE, void *, CMS *);

#endif 	// LQRN_HH
