/*
	lqr_modulemain.cc

	This file provides the C++ main function which
	creates and runs the following control modules:

		LQR_MODULE

	MODIFICATIONS:
	13-Sep-99	Created.

*/

// Include Files
#include <stdlib.h>	// exit()
#include <signal.h>	// SIGINT, signal()
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "lqr.hh"	// definition of LQR_MODULE

// flag signifying main loop is to terminate
int lqr_module_done = 0;

//signal handler for ^C
extern "C" void lqr_module_quit(int sig);
void lqr_module_quit(int sig)
{
	lqr_module_done = 1;
}

// main loop, running 1 controller(s)
#ifdef VXWORKS
extern "C" int lqr_module_run();

int lqr_module_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	RCS_TIMER *timer = new RCS_TIMER(0.1);
	LQR_MODULE *lqr = new LQR_MODULE();

	// set the SIGINT handler
	signal(SIGINT, lqr_module_quit);

	// enter main loop
	while(!lqr_module_done)
	{
		lqr->controller();

		timer->wait();
	}

	// Delete Modules
	delete lqr;

	// Delete Timer
	delete timer;
}

