/*
	lqr_modulesvr.cc

	This C++ file provides a main routin to start an NML server for this application
	It connects to all of the NML channels used by this application.
	If they are all valid it will call run_nml_servers(), otherwise it will exit immediately.

	MODIFICATIONS:
	13-Sep-99	Created.

*/

// Include Files
#include <stdlib.h> // exit()
#include "rcs.hh" 	// Common RCS definitions
#include "lqrn.hh" 	// lqrFormat

// NML Channel Pointers
static RCS_CMD_CHANNEL *lqr_cmd = NULL;
static RCS_STAT_CHANNEL *lqr_stat = NULL;
static NML *errlog = NULL;

static int InitNML()
{


	// lqr
	lqr_cmd = new RCS_CMD_CHANNEL(lqrFormat, "lqr_cmd", "lqr_modulesvr", "lqr_module.nml");
	if(NULL == lqr_cmd)
		return -1;
	if(!lqr_cmd->valid())
		return -1;

	lqr_stat = new RCS_STAT_CHANNEL(lqrFormat, "lqr_sts", "lqr_modulesvr", "lqr_module.nml");
	if(NULL == lqr_stat)
		return -1;
	if(!lqr_stat->valid())
		return -1;

	errlog = new NML(nmlErrorFormat, "errlog", "lqr_modulesvr", "lqr_module.nml");
	if(NULL == errlog)
		return -1;
	if(!errlog->valid())
		return -1;

	return 0;
}

static void DeleteNML()
{

	// lqr
	if(NULL != lqr_cmd)
	{
		delete lqr_cmd;
		lqr_cmd = NULL;
	}

	if(NULL != lqr_stat)
	{
		delete lqr_stat;
		lqr_stat = NULL;
	}

	if(NULL != errlog)
	{
		delete errlog;
		errlog = NULL;
	}

}

// Main 
#ifdef VXWORKS
extern "C" int lqr_modulesvr_run();

int lqr_modulesvr_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	if(InitNML() < 0)
	{
		DeleteNML();
		rcs_exit(-1);
	}

	run_nml_servers();

}

